﻿InterruptAssist = LibStub("AceAddon-3.0"):NewAddon("InterruptAssist", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("InterruptAssist")

local bit_band = _G.bit.band
local bit_bor  = _G.bit.bor
local AFFILIATION_IN_GROUP = bit_bor(COMBATLOG_OBJECT_AFFILIATION_PARTY, COMBATLOG_OBJECT_AFFILIATION_RAID, COMBATLOG_OBJECT_AFFILIATION_MINE)
local HUMAN_CONTROLLED = bit_bor(COMBATLOG_OBJECT_TYPE_PLAYER, COMBATLOG_OBJECT_CONTROL_PLAYER)
local IAChatFrame = DEFAULT_CHAT_FRAME

local debugMode = { [0] = L["Disabled"], [1] = L["Critical"], [2]=L["Standard"], [3] =L["Verbose"]}

local IACurrentDBVersion = 1

InterruptAssist.options = 
{
	name = "InterruptAssist",
	handler = InterruptAssist,
	type = 'group',
	args = 
	{
	
		debug =
		{
			name = L["Debugging"],
			type = 'select',
			values = { [0] = L["Disabled"], [1] = L["Critical"], [2]=L["Standard"], [3] =L["Verbose"] },
			order = 3,
			hidden = true,
			desc = L["Select the amount of desired debug messages. Should be disabled for normal users."],
			style = 'dropdown',
			set = 'SetDebugLevel',
			get = 'GetDebugLevel',
		},
		
		General =
		{
			name = L["General"],
			type = 'group',
			desc = L["General Settings"],
			args = 
			{
				enable = 
				{
					name = L["Enable"],
					type = 'toggle',
					order = 1,
					desc = L["Enables/disables this addon"],
					set = 'SetEnable',
					get = 'GetEnable',
				},
				trash = 
				{
					type = 'toggle',
					name = L["Trash"],
					order = 2,
					desc = L["Enables/disables trash mob monitoring. Be advised that this only works correctly, if you target the unit, that you interrupt. Results can be wrong if mouseover macros and the like are used."],
					set = 'SetTrash',
					get = 'GetTrash',
				},
				silence = 
				{
					type = 'toggle',
					name = L["Silent operation"],
					order = 3,
					desc = L["If enabled changing configuration options will not send any confirmation messages."],
					set = 'SetSilence',
					get = 'GetSilence',
				},
				timestamped =
				{
					type = 'toggle',
					name = L["Timestamp"],
					order = 4,
					desc = L["If enabled all announcements will include a detailed timestamp."],
					set = 'SetTimestamped',
					get = 'GetTimestamped',
				},
				includeTarget =
				{
					type = 'toggle',
					name = L["Target"],
					order = 4,
					desc = L["If enabled all announcements will include the target of the interrupt."],
					set = 'SetIncludeTarget',
					get = 'GetIncludeTarget',
				},
			},
		},
		Rotations =
		{
			name = L["Rotations"],
			type = 'group',
			desc = L["Setup one or more interrupt rotations."],
			args =
			{
				Participants =
				{
					name = L["Number of participants"],
					type = 'range',
					desc = L["Select how many players shall participate in this rotation. Choosing 1 disables it."],
					step = 1,
					min = 1,
					max = 4,
					order = 1,
					set = 'SetNumParticipants',
					get = 'GetNumParticipants',
				},
				
				Participant_1 =
				{
					name = L["First interrupter"],
					type = 'input',
					desc = L["Enter the first member of your interrupt rotation here"],
					order = 2,
					hidden = 'IsFirstInterruptorInactive',
					disabled = 'IsFirstInterruptorInactive',
					set = 'Set1stParticipant',
					get = 'Get1stParticipant'
				},
				
				Participant_2 =
				{
					name = L["Second interrupter"],
					type = 'input',
					desc = L["Enter the second member of your interrupt rotation here"],
					order = 3,
					hidden = 'IsSecondInterruptorInactive',
					disabled = 'IsSecondInterruptorInactive',
					set = 'Set2ndParticipant',
					get = 'Get2ndParticipant'
				},

				Participant_3 =
				{
					name = L["Third interrupter"],
					type = 'input',
					desc = L["Enter the third member of your interrupt rotation here"],
					order = 4,
					hidden = 'IsThirdInterruptorInactive',
					disabled = 'IsThirdInterruptorInactive',
					set = 'Set3rdParticipant',
					get = 'Get3rdParticipant'
				},				

				Participant_4 =
				{
					name = L["Fourth interrupter"],
					type = 'input',
					desc = L["Enter the fourth member of your interrupt rotation here"],
					order = 5,
					hidden = 'IsFourthInterruptorInactive',
					disabled = 'IsFourthInterruptorInactive',
					set = 'Set4thParticipant',
					get = 'Get4thParticipant'
				},
			--[[
			*
			* Considered allowing several rotations to be entered, but for the time being removed this. 
			*
				active_Rotations =
				{
					name = L["Active Rotations"],
					type = 'range',
					desc = L["Select how many interrupt rotations you wish to enter"],
					step = 1,
					min = 0,
					max = 4,
					set = 'SetNumRotations',
					get = 'GetNumRotations',
				},
				
				Rotation_1 =
				{
					name = L["First rotation"],
					type = 'group',
					desc = L["Setup the first interrupt rotation."],
					order = 1,
					args =
					{
						silence = 
						{
							type = 'toggle',
							name = L["Silent operation"],
							order = 1,
							desc = L["If enabled changing configuration options will not send any confirmation messages."],
							set = 'SetSilence',
							get = 'GetSilence',
						},
					},
				},
				
				Rotation_2 =
				{
					name = L["Second rotation"],
					type = 'group',
					desc = L["Setup the second interrupt rotation."],
					order = 2,
					args =
					{
						silence = 
						{
							type = 'toggle',
							name = L["Silent operation"],
							order = 3,
							desc = L["If enabled changing configuration options will not send any confirmation messages."],
							set = 'SetSilence',
							get = 'GetSilence',
						},
					},
				},
				
				Rotation_3 =
				{
					name = L["Third rotation"],
					type = 'group',
					desc = L["Setup the third interrupt rotation."],
					order = 3,
					args =
					{
						silence = 
						{
							type = 'toggle',
							name = L["Silent operation"],
							order = 3,
							desc = L["If enabled changing configuration options will not send any confirmation messages."],
							set = 'SetSilence',
							get = 'GetSilence',
						},
					},
				},				

				Rotation_4 =
				{
					name = L["Fourth rotation"],
					type = 'group',
					desc = L["Setup the fourth interrupt rotation."],
					order = 4,
					args =
					{
						silence = 
						{
							type = 'toggle',
							name = L["Silent operation"],
							order = 3,
							desc = L["If enabled changing configuration options will not send any confirmation messages."],
							set = 'SetSilence',
							get = 'GetSilence',
						},
					},
				},]]--
			},
		},
		
		Output =
		{
			name = L["Output"],
			type = 'group',
			desc = L["Customise your output settings"],
			args =
			{

				say = 
				{
					type = 'toggle',
					name = L["Say"],
					order = 1,
					desc = L["Enables/disables output to the say channel"],
					set = 'SetSay',
					get = 'GetSay',
				},
				
				party = 
				{
					type = 'toggle',
					name = L["Party"],
					order = 2,
					desc = L["Enables/disables output to the party channel"],
					set = 'SetParty',
					get = 'GetParty',
				},
				
				raid = 
				{
					type = 'toggle',
					name = L["Raid"],
					order = 3,
					desc = L["Enables/disables output to the raid channel"],
					set = 'SetRaid',
					get = 'GetRaid',
				},
				
				localChat = 
				{
					type = 'toggle',
					name = L["Local"],
					order = 4,
					desc = L["Enables/disables output to the local chatframe"],
					set = 'SetLocal',
					get = 'GetLocal',
				},
			},
		},
	},
}

local defaults = 
{
	char = 
	{
		debuglevel = 0,
		silence = true,
		dbversion = 1,
		enable = true,
		trash = true,
		includeTarget = false,
		timestamped = false,
		say = false,
		party = false,
		raid = false,
		localChat = true,
		numberRotations = 0,
		numberParticipants = 1,
		Interrupters = { [0] = L["Nobody"] , [1] = L["Nobody"], [2]= L["Nobody"] , [3] = L["Nobody"] },
	},
}

function InterruptAssist:OnInitialize()
	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("InterruptAssistDB", defaults)	
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("InterruptAssist", self.options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("InterruptAssist", "InterruptAssist")
	self:RegisterChatCommand("ia", "ChatCommand")
	self:RegisterChatCommand("InterruptAssist", "ChatCommand")
end

function InterruptAssist:ChatCommand(input)
    if not input or input:trim() == "" then
        LibStub("AceConfigDialog-3.0"):Open("InterruptAssist")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(InterruptAssist, "ia", "InterruptAssist", input)
    end
end

function InterruptAssist:OnEnable()
	-- Called when the addon is enabled
	if (self:GetEnable()) then
		InterruptAssist:RegisterEvent("PLAYER_TARGET_CHANGED")
		InterruptAssist:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self.myGUID = UnitGUID("player")
	end
end

function InterruptAssist:OnDisable()
	-- Called when the addon is disabled
	InterruptAssist:UnregisterEvent("PLAYER_TARGET_CHANGED")
	InterruptAssist:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function InterruptAssist:IsDebuggingEnabled(info)
	--Returns true if the addon is in debug mode or false if it isn't.
	if (self:GetDebugLevel() > 0) then
		return true
	else
		return false
	end
end

function InterruptAssist:SetDebugLevel(info, val)
	-- Sets the level of verbosity for Debug messages. Ranges from zero (disabled) to three (all Debug messages).
	self.db.char.debuglevel = val
	if (self.db.char.silence == false) then
		self:Print(L["Set Debugging to X"](debugMode[val]));
	end
end

function InterruptAssist:GetDebugLevel()
	return self.db.char.debuglevel
end

function InterruptAssist:DebugPrint(message, level)
	-- Used to keep the code 'clean'. Whenever a debug message is generated it is passed 
	-- to this function, which then checks whether the addon is actually in debug mode or not.
	-- Level denotes the importance of the debug message. 
	if (self:IsDebuggingEnabled()) then
		if (self:GetDebugLevel() >= level) then
			self:Print("Debug: "..message)
		end
	end
end

function InterruptAssist:SetEnable(info, val)
	--Enables and Disables the addon.
	self.db.char.enable = val
	
	if (self.db.char.enable) then
		self:OnEnable();
		if (self.db.char.silence == false) then
			self:Print(L["Addon has been enabled."]);
		end
	else
		self:OnDisable();
		if (self.db.char.silence == false) then
			self:Print(L["Addon has been disabled."]);
		end
	end
end

function InterruptAssist:GetEnable(info)
	return self.db.char.enable
end

function InterruptAssist:SetSilence(info, val)
	--Enables and disables silent operation
	self.db.char.silence = val
	
	if (self.db.char.silence == false) then
		self:Print(L["Silent operation has been disabled."]);
	end
end

function InterruptAssist:GetSilence(info)
	return self.db.char.silence
end

function InterruptAssist:SetTimestamped(info, val)
	self.db.char.timestamped = val
	
	if (self.db.char.silence == false) then
		if (self.db.char.timestamped) then
			self:Print(L["Announcements are now timestamped."]);
		else
			self:Print(L["Announcements are no longer timestamped."]);
		end
	end
end

function InterruptAssist:GetTimestamped(info)
	return self.db.char.timestamped
end

function InterruptAssist:SetIncludeTarget(info, val)
	self.db.char.includeTarget = val
	
	if (self.db.char.silence == false) then
		if (self.db.char.includeTarget) then
			self:Print(L["Announcements now include the target of the interrupt."]);
		else
			self:Print(L["Announcements no longer include the target of the interrupt."]);
		end
	end
end

function InterruptAssist:GetIncludeTarget(info)
	return self.db.char.includeTarget
end

function InterruptAssist:SetTrash(info, val)
	self.db.char.trash = val
	
	if (self.db.char.silence == false) then
		if (self.db.char.trash) then
			self:Print(L["Trash mob monitoring enabled."]);
		else
			self:Print(L["Trash mob monitoring disabled."]);
		end
	end
end

function InterruptAssist:GetTrash(info)
	return self.db.char.trash
end

function InterruptAssist:SetSay(info, val)
	self.db.char.say = val
	
	if (self.db.char.silence == false) then
		if (self.db.char.say) then
			self:Print(L["Output is now sent to say channel."]);
		else
			self:Print(L["Output is no longer sent to say channel."]);
		end
	end
end

function InterruptAssist:GetSay(info)
	return self.db.char.say
end

function InterruptAssist:SetParty(info, val)
	self.db.char.party = val
	
	if (self.db.char.silence == false) then
		if (self.db.char.party) then
			self:Print(L["Output is now sent to party channel."]);
		else
			self:Print(L["Output is no longer sent to party channel."]);
		end
	end
end

function InterruptAssist:GetParty(info)
	return self.db.char.party
end

function InterruptAssist:SetRaid(info, val)
	self.db.char.raid = val
	
	if (self.db.char.silence == false) then
		if (self.db.char.raid) then
			self:Print(L["Output is now sent to raid channel."]);
		else
			self:Print(L["Output is no longer sent to raid channel."]);
		end
	end
end

function InterruptAssist:GetRaid(info)
	return self.db.char.raid
end

function InterruptAssist:SetLocal(info, val)
	self.db.char.localChat = val
	
	if (self.db.char.silence == false) then
		if (self.db.char.localChat) then
			self:Print(L["Output is now sent to local chatframe."]);
		else
			self:Print(L["Output is no longer sent to local chatframe."]);
		end
	end
end

function InterruptAssist:GetLocal(info)
	return self.db.char.localChat
end

function InterruptAssist:SetNumParticipants(info, val)
	self.db.char.numberParticipants = val
end

function InterruptAssist:GetNumParticipants(info)
	return self.db.char.numberParticipants
end

function InterruptAssist:IsRotationActive ()
	if (self.db.char.numberParticipants >= 2) then
		return true
	else
		return false
	end
end

function InterruptAssist:SetNumRotations(info, val)
	self.db.char.numberRotations = val
end

function InterruptAssist:GetNumRotations(info)
	return self.db.char.numberRotations
end

function InterruptAssist:Set1stParticipant(info, val)
	self.db.char.Interrupters[0] = val
end

function InterruptAssist:Get1stParticipant(info)
	return self.db.char.Interrupters[0]
end

function InterruptAssist:Set2ndParticipant(info, val)
	self.db.char.Interrupters[1] = val
end

function InterruptAssist:Get2ndParticipant(info)
	return self.db.char.Interrupters[1]
end

function InterruptAssist:Set3rdParticipant(info, val)
	self.db.char.Interrupters[2] = val
end

function InterruptAssist:Get3rdParticipant(info)
	return self.db.char.Interrupters[2]
end

function InterruptAssist:Set4thParticipant(info, val)
	self.db.char.Interrupters[3] = val
end

function InterruptAssist:Get4thParticipant(info)
	return self.db.char.Interrupters[3]
end

function InterruptAssist:IsInterruptorInactive (val)

	if (self.db.char.numberParticipants <= 1) then
		return true
	end
	
	if (self.db.char.numberParticipants >= val) then
		return false
	else
		return true
	end
end

function InterruptAssist:IsFirstInterruptorInactive(info)
	return self:IsInterruptorInactive (1);
end

function InterruptAssist:IsSecondInterruptorInactive(info)
	return self:IsInterruptorInactive (2);
end

function InterruptAssist:IsThirdInterruptorInactive(info)
	return self:IsInterruptorInactive (3);
end

function InterruptAssist:IsFourthInterruptorInactive(info)
	return self:IsInterruptorInactive (4);
end

function InterruptAssist:PLAYER_TARGET_CHANGED()
	self.myTargetGUID = UnitGUID("target")
	if (self:IsDebuggingEnabled()) then
		local targetName = UnitName("target");
		if (targetName) then 
			self:DebugPrint (L["Target changed to X (y)"](targetName, UnitLevel("target")),3);
		end
	end
end

-- Added hideCaster to the parameter list to make the mod compatible with 4.1.0 . No idea yet what the flag actually does and whether I will have to evaluate it in the future.
-- Added sourceRaidFlags and destRaidFlags to the parameter list to make the mod compatible with 4.2.0
function InterruptAssist:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, subEvent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, ...)
	
	-- Check if the addon is enabled. Early revisions had a problem with OnEnable/OnDisable, that made this
	-- check neccessary. Left here "just in case".
	if (self:GetEnable() == false) then
		return
	end
	
	if (subEvent == "SPELL_INTERRUPT") then
		
		if (self:GetTrash() == false) then
			if (UnitLevel(sourceName.."-target") > 0) then
				return
			end
		end
	
		local spellID, spellName, spellSchool, extraSpellID, extraSpellName, extraSpellSchool = select(1, ...)
		if (sourceGUID == self.myGUID) then
				--self:Print ("I interrupted " .. destName .. " while he tried to cast " .. GetSpellLink (extraSpellID) .. " with " .. spellName);
				self:ReportInterrupt (timestamp, sourceName, destName, spellName, extraSpellID);
		end
	end -- if subEvent == SPELL_INTERRUPT
end

function InterruptAssist:ReportInterrupt (timestamp, sourceName, destName, spellName , extraSpellID)
	sOutput = ""

	if (self:GetIncludeTarget()) then
		sOutput = "Interrupted " .. destName .. " casting: " .. GetSpellLink (extraSpellID);
	else
		sOutput = "Interrupted: " .. GetSpellLink (extraSpellID);
	end
	
	if (self:GetTimestamped()) then
		sOutput = "[" .. self:FormatTimestamp (timestamp) .. "] " .. sOutput;
	end
	
	if (self:IsRotationActive()) then
		iIndex = 0;
		while (iIndex < self.db.char.numberParticipants) do
			if (self.db.char.Interrupters [iIndex] == sourceName) then
				if (iIndex+1 < self.db.char.numberParticipants) then
					sOutput = sOutput .. " - " .. self.db.char.Interrupters [iIndex+1] .. " is next."
				else
					sOutput = sOutput .. " - " .. self.db.char.Interrupters [0] .. " is next."
				end
			end
			iIndex = iIndex+1;
		end
	end
	
	if (self:GetLocal()) then
		self:Print (sOutput);
	end
	
	if (self:GetSay ()) then
		SendChatMessage (sOutput, "SAY")
	end
	
	if (self:GetParty ()) then
		SendChatMessage (sOutput, "PARTY")
	end
	
	if (self:GetRaid ()) then
		SendChatMessage (sOutput, "RAID")
	end	
end

-- Function expects a timestamp from the combat log and formats it to Hours:Minutes:Seconds.Milliseconds
function InterruptAssist:FormatTimestamp (timestamp)
	local milliseconds = (timestamp - floor(timestamp))*1000
	local formattedTimestamp = (date("%H:%M:%S",timestamp) .. format(".%03d", milliseconds))
	return formattedTimestamp
end